<template>
  <div class="md-layout">
    <section class="keyvisual">
      <div class="inner flex sp-block">
        <div class="kv-ime">
          <figure class="img">
            <img :src="largeIconImageUrl" decoding="async" />
          </figure>
        </div>
        <div class="body scenario-body">
          <p class="scenario-type-text">
            {{ readableScenarioListType }}
            <span style="vertical-align: 2px"> > </span>
            {{ categoryName }}
          </p>
          <h2 class="kv-title">{{ name }}</h2>
          <div class="value flex-col-center">
            <div class="mark flex" v-if="numberOfRatings > 0">
              <figure
                v-for="(i, index) in ratingStars"
                v-bind:key="'rating-star-1-' + index"
              >
                <img
                  src="../../assets/images/star_yellow_full.png"
                  v-if="i == 'F'"
                />
                <img
                  src="../../assets/images/star_yellow_half.png"
                  v-if="i == 'H'"
                />
                <img
                  src="../../assets/images/star_yellow_empty.png"
                  v-if="i == 'E'"
                />
              </figure>
            </div>
            <div class="mark flex" v-else>
              <figure>
                <img src="../../assets/images/star_gray_empty.png" />
                <img src="../../assets/images/star_gray_empty.png" />
                <img src="../../assets/images/star_gray_empty.png" />
                <img src="../../assets/images/star_gray_empty.png" />
                <img src="../../assets/images/star_gray_empty.png" />
              </figure>
            </div>
            <p class="num">({{ numberOfRatings }})</p>
            <p class="year">{{ publishedAt | moment_simple }}</p>
          </div>
          <p class="text" v-html="playerSettingsDescription"></p>
        </div>
      </div>
    </section>

    <section class="rate">
      <div class="contents-inner flex sp-block">
        <div class="value">
          <h3 class="rate-title">このコンテンツへの評価</h3>
          <div class="value-box flex sp-block">
            <div class="left sp-flex-center">
              <p class="num">{{ averageRating }}</p>
              <div>
                <div class="mark flex-col-center">
                  <figure
                    v-for="(i, index) in ratingStars"
                    v-bind:key="'rating-star-2-' + index"
                  >
                    <img
                      src="../../assets/images/star_yellow_full.png"
                      v-if="i == 'F'"
                    />
                    <img
                      src="../../assets/images/star_yellow_half.png"
                      v-if="i == 'H'"
                    />
                    <img
                      src="../../assets/images/star_yellow_empty.png"
                      v-if="i == 'E'"
                    />
                  </figure>
                </div>
                <p class="text">{{ numberOfReviews }}件のレビュー</p>
              </div>
            </div>
            <div class="right">
              <div class="marks flex">
                <p class="percent">{{ percentageRatings[4] }}%</p>
                <progress max="100" :value="percentageRatings[4]"></progress>
                <div class="mark flex">
                  <img src="../../assets/images/star_yellow_full.png" />
                  <img src="../../assets/images/star_yellow_full.png" />
                  <img src="../../assets/images/star_yellow_full.png" />
                  <img src="../../assets/images/star_yellow_full.png" />
                  <img src="../../assets/images/star_yellow_full.png" />
                </div>
              </div>
              <div class="marks flex">
                <p class="percent">{{ percentageRatings[3] }}%</p>
                <progress max="100" :value="percentageRatings[3]"></progress>
                <div class="mark flex">
                  <img src="../../assets/images/star_yellow_full.png" />
                  <img src="../../assets/images/star_yellow_full.png" />
                  <img src="../../assets/images/star_yellow_full.png" />
                  <img src="../../assets/images/star_yellow_full.png" />
                  <img src="../../assets/images/star_yellow_empty.png" />
                </div>
              </div>
              <div class="marks flex">
                <p class="percent">{{ percentageRatings[2] }}%</p>
                <progress max="100" :value="percentageRatings[2]"></progress>
                <div class="mark flex">
                  <img src="../../assets/images/star_yellow_full.png" />
                  <img src="../../assets/images/star_yellow_full.png" />
                  <img src="../../assets/images/star_yellow_full.png" />
                  <img src="../../assets/images/star_yellow_empty.png" />
                  <img src="../../assets/images/star_yellow_empty.png" />
                </div>
              </div>
              <div class="marks flex">
                <p class="percent">{{ percentageRatings[1] }}%</p>
                <progress max="100" :value="percentageRatings[1]"></progress>
                <div class="mark flex">
                  <img src="../../assets/images/star_yellow_full.png" />
                  <img src="../../assets/images/star_yellow_full.png" />
                  <img src="../../assets/images/star_yellow_empty.png" />
                  <img src="../../assets/images/star_yellow_empty.png" />
                  <img src="../../assets/images/star_yellow_empty.png" />
                </div>
              </div>
              <div class="marks flex">
                <p class="percent">{{ percentageRatings[0] }}%</p>
                <progress max="100" :value="percentageRatings[0]"></progress>
                <div class="mark flex">
                  <img src="../../assets/images/star_yellow_full.png" />
                  <img src="../../assets/images/star_yellow_empty.png" />
                  <img src="../../assets/images/star_yellow_empty.png" />
                  <img src="../../assets/images/star_yellow_empty.png" />
                  <img src="../../assets/images/star_yellow_empty.png" />
                </div>
              </div>
            </div>
          </div>
          <a
            class="btn flex-center pen"
            :href="`/console/libraries/scenario/${id}`"
            >評価とレビューを書いてみる</a
          >
        </div>
        <div class="review" v-if="reviews.length > 0">
          <h3 class="rate-title">このコンテンツへのレビュー</h3>
          <div class="review-box">
            <div
              class="box flex"
              v-for="review in reviews"
              v-bind:key="'review_id_' + review.id"
            >
              <figure class="avatar">
                <img
                  :src="review.user.icon_image_url"
                  class="user-icon-border"
                  decoding="async"
                />
              </figure>
              <div class="body">
                <p class="name">{{ review.user.name }}</p>
                <div class="mark flex">
                  <figure
                    v-for="i in review.rating"
                    v-bind:key="'review_id_' + review.id + '_enable_star_' + i"
                  >
                    <img src="../../assets/images/star_yellow_full.png" />
                  </figure>
                  <figure
                    v-for="i in 5 - review.rating"
                    v-bind:key="'review_id_' + review.id + '_disable_star_' + i"
                  >
                    <img src="../../assets/images/star_yellow_empty.png" />
                  </figure>
                </div>
                <p class="comment" v-html="review.comment"></p>
              </div>
            </div>
          </div>
        </div>
        <div class="review" v-else>
          <p>
            この動画はまだレビューが存在しません。<br />
            1番にレビューを書いてみませんか？
          </p>
        </div>
      </div>
    </section>

    <section class="slide-contents border">
      <div class="contents-inner">
        <h2 class="contents-title bold">このコンテンツに関連</h2>
        <div class="slider-wrapper">
          <div class="slider">
            <a
              v-for="scenario in relatingScenarios"
              :key="scenario.id"
              :href="`/libraries/scenario/${scenario.id}`"
            >
              <div class="slider-body">
                <div class="slider-img">
                  <figure class="img">
                    <img
                      :src="scenario.icon_image_url"
                      class="curriculum-scenario-img"
                      decoding="async"
                    />
                  </figure>
                  <figure class="icon">
                    <img
                      :src="scenario.feature_icon_image_url"
                      class="scenario-icon-img"
                      decoding="async"
                    />
                  </figure>
                </div>
                <p class="title">{{ scenario.name }}</p>
              </div>
            </a>
          </div>
        </div>
      </div>
    </section>
  </div>
</template>

<script>
import $ from 'jquery';
import 'slick-carousel';
import { mapActions, mapGetters } from 'vuex';
import arrowRightImage from '/images/arrow_right.png';
import arrowLeftImage from '/images/arrow_left.png';

export default {
  data() {
    return {
      es: [],
      id: '',
      name: '',
      playerSettingsDescription: '',
      largeIconImageUrl: '',
      publishedAt: '',
      tagList: [],
      readableScenarioListType: '',
      teamName: '',
      categoryName: '',
      numberOfReviews: 0,
      numberOfRatings: 0,
      averageRating: 0,
      percentageRatings: [],
      ratingStars: [],
      relatingScenarios: [],
      reviews: [],
      page: 0,
      reviewId: '',
      reviewUuid: '',
    };
  },
  watch: {
    $route(to, from) {
      window.scroll({ top: 0, behavior: 'instant' });
      this.$router.go({ path: this.$router.currentRoute.path, force: true });
      window.location.reload();
    },
  },
  mounted() {
    window.scroll({ top: 0, behavior: 'instant' });
    this.id = this.$route.params.id;
    this.fetchLibrariesScenario(this.id)
      .then((e) => {
        this.name = e.data.name;
        this.playerSettingsDescription = e.data.player_settings_description;
        this.largeIconImageUrl = e.data.large_icon_image_url;
        this.publishedAt = e.data.published_at;
        this.tagList = e.data.tag_list;
        this.readableScenarioListType = e.data.readable_scenario_list_type;
        this.teamName = e.data.team.name;
        this.categoryName = e.data.category.name;
        this.numberOfReviews = e.data.number_of_reviews;
        this.numberOfRatings = e.data.number_of_ratings;
        this.averageRating = e.data.average_rating;
        this.percentageRatings = e.data.percentage_ratings;
        this.ratingStars = e.data.rating_stars;
        this.relatingScenarios = e.data.relating_scenarios;

        this.setSliderClass();

        // タイトルとdescriptionを更新する
        var description = e.data.meta_description;

        document.title = this.name + '| ' + this.$t('site_title');
        document
          .querySelector("meta[name='description']")
          ?.setAttribute('content', description);
        document
          .querySelector("meta[property='og:description']")
          ?.setAttribute('content', description);
        document
          .querySelector("meta[name='twitter:description']")
          ?.setAttribute('content', description);
        document
          .querySelector("meta[name='og:image']")
          ?.setAttribute('content', this.largeIconImageUrl);
        document
          .querySelector("meta[name='twitter:image']")
          ?.setAttribute('content', this.largeIconImageUrl);
      })
      .catch((e) => {
        alert(e);
        this.$router.push({ path: '/console/' });
      });

    const params = {
      id: this.id,
    };
    this.fetchLibrariesReviewPublic(params)
      .then((res) => {
        this.reviews = res.data.reviews;
      })
      .catch(() => {
        this.$router.push({ path: '/console/' });
      });
  },
  computed: {
    ...mapGetters(['currentUser', 'consoleConfigs']),
    current_user() {
      return this.currentUser;
    },
    configs() {
      return this.consoleConfigs;
    },
  },
  methods: {
    ...mapActions([
      'storeCurrentPath',
      'fetchLibrariesReview',
      'fetchLibrariesReviewPublic',
      'fetchLibrariesScenario',
    ]),
    setSliderClass: function () {
      $(function () {
        $('.slider').slick({
          arrows: true,
          autoplay: false,
          slidesToShow: 4,
          slidesToScroll: 1,
          centerMode: false,
          variableWidth: false,
          infinite: false,
          nextArrow:
            '<img src="' + arrowRightImage + '" class="slide-arrow nextArrow">',
          prevArrow:
            '<img src="' + arrowLeftImage + '" class="slide-arrow prevArrow">',
          responsive: [
            {
              breakpoint: 768,
              settings: {
                infinite: false,
                variableWidth: false,
                arrows: false,
                slidesToShow: 2,
                slidesToScroll: 2,
                centerMode: false,
              },
            },
          ],
        });
      });
    },
  },
};
</script>

<style lang="scss" scoped>
.scenario-body {
  background: rgba(40, 45, 55, 1);
}
.scenario-type-text {
  font-weight: 500;
  font-size: 14px;
  line-height: 27px;
  color: #9da0a5;
  margin-bottom: 60px;
}
@media screen and (max-width: 767px) {
  .scenario-type-text {
    margin-bottom: 12px;
    margin-top: 0;
    padding-top: 12px;
  }
}
.slider {
  background-color: white;
}
</style>
